Index: /trunk/src/sys/arch/mipsco/mipsco/mips_3x30.c
===================================================================
--- /trunk/src/sys/arch/mipsco/mipsco/mips_3x30.c	(revision 151)
+++ /trunk/src/sys/arch/mipsco/mipsco/mips_3x30.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: mips_3x30.c,v 1.10.18.1 2010/02/01 04:18:31 matt Exp $	*/
+/*	$NetBSD: mips_3x30.c,v 1.10.18.2 2010/12/29 08:16:21 matt Exp $	*/
 
 /*
@@ -30,6 +30,7 @@
  */
 
+#define	__INTR_PRIVATE
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mips_3x30.c,v 1.10.18.1 2010/02/01 04:18:31 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: mips_3x30.c,v 1.10.18.2 2010/12/29 08:16:21 matt Exp $");
 
 #include <sys/param.h>
@@ -38,9 +39,9 @@
 #include <sys/proc.h>
 #include <sys/kernel.h>
+#include <sys/cpu.h>
+#include <sys/intr.h>
 
 #include <machine/trap.h>
 #include <machine/psl.h>
-#include <machine/cpu.h>
-#include <machine/intr.h>
 #include <machine/mainboard.h>
 #include <machine/sysconf.h>
@@ -50,7 +51,7 @@
 /* Local functions */
 void pizazz_init (void);
-void pizazz_intr (u_int, u_int, u_int, u_int);
+void pizazz_intr (uint32_t, vaddr_t, uint32_t);
 int  pizazz_level0_intr (void *);
-void pizazz_level5_intr (int, int, int);
+void pizazz_level5_intr (uint32_t, vaddr_t);
 void pizazz_intr_establish  (int, int (*)(void *), void *);
 
@@ -64,4 +65,6 @@
 	platform.iointr = pizazz_intr;
 	platform.intr_establish = pizazz_intr_establish;
+
+	ipl_sr_map = mipsco_ipl_sr_map;
 
 	pizazz_intr_establish(SYS_INTR_LEVEL0, pizazz_level0_intr, NULL);
@@ -79,9 +82,5 @@
 
 void
-pizazz_intr(status, cause, pc, ipending)
-	u_int status;	/* status register at time of the exception */
-	u_int cause;	/* cause register at time of exception */
-	u_int pc;	/* program counter where to continue */
-	u_int ipending;
+pizazz_intr(uint32_t status, vaddr_t pc, uint32_t ipending)
 {
 	/* handle clock interrupts ASAP */
@@ -92,16 +91,11 @@
 		cf.pc = pc;
 		cf.sr = status;
+		cf.intr = (curcpu()->ci_idepth > 0);
 
 		rambo_clkintr(&cf);
-
-		/* keep clock interrupts enabled when we return */
-		cause &= ~MIPS_INT_MASK_2;
 	}
 
-	/* If clock interrupts were enabled, re-enable them ASAP. */
-	_splset(MIPS_SR_INT_IE | (status & MIPS_INT_MASK_2));
-
 	if (ipending & MIPS_INT_MASK_5)		/* level 5 interrupt */
-		pizazz_level5_intr(pc, cause, status);
+		pizazz_level5_intr(status, pc);
 
 	HANDLE_INTR(SYS_INTR_FDC,	MIPS_INT_MASK_4);
@@ -109,16 +103,11 @@
 	HANDLE_INTR(SYS_INTR_LEVEL0,	MIPS_INT_MASK_0);
 
-	/* XXX:  Keep FDC interrupt masked off */
-	cause &= ~(MIPS_INT_MASK_0 | MIPS_INT_MASK_1 | MIPS_INT_MASK_5);
-
-	_splset((status & ~cause & MIPS_HARD_INT_MASK) | MIPS_SR_INT_IE);
-
 #if !defined(NOFPU)
 	/* FPU nofiticaition */
 	if (ipending & INT_MASK_FPU) {
 		if (!USERMODE(status))
-			panic("kernel used FPU: PC %x, CR %x, SR %x",
-			      pc, cause, status);
-		MachFPInterrupt(status, cause, pc, curlwp->l_md.md_utf);
+			panic("kernel used FPU: PC %x, SR %x",
+			      pc, status);
+		MachFPInterrupt(status, 0, pc, curlwp->l_md.md_utf);
 	}
 #endif
@@ -156,8 +145,5 @@
  */
 void
-pizazz_level5_intr(pc, cause, status)
-	int pc;
-	int cause;
-	int status;
+pizazz_level5_intr(uint32_t status, vaddr_t pc)
 {
 	u_int32_t ereg;
@@ -165,5 +151,5 @@
 	ereg = *(u_int32_t *)RAMBO_ERREG;
 
-	printf("interrupt: pc=%p cr=%x sr=%x\n", (void *)pc, cause, status);
+	printf("interrupt: pc=%p sr=%x\n", (void *)pc, status);
 	printf("parity error: %p mask: 0x%x\n", (void *)ereg, ereg & 0xf);
 	panic("memory fault");
Index: /trunk/src/sys/arch/newsmips/apbus/apbus.c
===================================================================
--- /trunk/src/sys/arch/newsmips/apbus/apbus.c	(revision 151)
+++ /trunk/src/sys/arch/newsmips/apbus/apbus.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: apbus.c,v 1.21 2008/04/09 15:40:30 tsutsui Exp $	*/
+/*	$NetBSD: apbus.c,v 1.21.22.1 2010/12/29 08:14:42 matt Exp $	*/
 
 /*-
@@ -28,5 +28,7 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: apbus.c,v 1.21 2008/04/09 15:40:30 tsutsui Exp $");
+__KERNEL_RCSID(0, "$NetBSD: apbus.c,v 1.21.22.1 2010/12/29 08:14:42 matt Exp $");
+
+#define __INTR_PRIVATE
 
 #include <sys/param.h>
@@ -35,4 +37,5 @@
 #include <sys/device.h>
 #include <sys/proc.h>
+#include <sys/intr.h>
 
 #include <uvm/uvm_extern.h>
@@ -42,5 +45,4 @@
 #define _NEWSMIPS_BUS_DMA_PRIVATE
 #include <machine/bus.h>
-#include <machine/intr.h>
 #include <newsmips/apbus/apbusvar.h>
 
@@ -98,4 +100,6 @@
 	int i;
 
+	mips_set_wbflush(apbus_wbflush);
+
 	*(volatile uint32_t *)(NEWS5000_APBUS_INTST) = 0xffffffff;
 	*(volatile uint32_t *)(NEWS5000_APBUS_INTMSK) = 0xffffffff;
@@ -177,7 +181,8 @@
 apbus_wbflush(void)
 {
-	volatile int32_t *wbflush = (uint32_t *)NEWS5000_WBFLUSH;
-
-	(void)*wbflush;
+	volatile int32_t * const our_wbflush = (int32_t *)NEWS5000_WBFLUSH;
+
+	(*mips_locore_jumpvec.ljv_wbflush)();
+	(void)*our_wbflush;
 }
 
Index: /trunk/src/sys/arch/newsmips/apbus/if_snvar.h
===================================================================
--- /trunk/src/sys/arch/newsmips/apbus/if_snvar.h	(revision 151)
+++ /trunk/src/sys/arch/newsmips/apbus/if_snvar.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: if_snvar.h,v 1.12 2008/04/09 15:40:30 tsutsui Exp $	*/
+/*	$NetBSD: if_snvar.h,v 1.12.22.1 2010/12/29 08:14:42 matt Exp $	*/
 
 /*
@@ -33,12 +33,4 @@
 
 #include <mips/locore.h>
-#undef wbflush	/* XXX */
-
-static inline void
-wbflush(void)
-{
-	mips3_wbflush();
-	apbus_wbflush();
-};
 
 /*
Index: /trunk/src/sys/arch/newsmips/dev/hb.c
===================================================================
--- /trunk/src/sys/arch/newsmips/dev/hb.c	(revision 151)
+++ /trunk/src/sys/arch/newsmips/dev/hb.c	(revision 152)
@@ -1,14 +1,15 @@
-/*	$NetBSD: hb.c,v 1.18 2008/04/09 15:40:30 tsutsui Exp $	*/
+/*	$NetBSD: hb.c,v 1.18.22.1 2010/12/29 08:14:43 matt Exp $	*/
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: hb.c,v 1.18 2008/04/09 15:40:30 tsutsui Exp $");
+__KERNEL_RCSID(0, "$NetBSD: hb.c,v 1.18.22.1 2010/12/29 08:14:43 matt Exp $");
 
+#define __INTR_PRIVATE
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/device.h>
 #include <sys/malloc.h>
+#include <sys/intr.h>
 
 #include <machine/autoconf.h>
-#include <machine/intr.h>
 
 #include <newsmips/dev/hbvar.h>
Index: /trunk/src/sys/arch/newsmips/dev/scsi_1185.c
===================================================================
--- /trunk/src/sys/arch/newsmips/dev/scsi_1185.c	(revision 151)
+++ /trunk/src/sys/arch/newsmips/dev/scsi_1185.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: scsi_1185.c,v 1.19 2008/04/09 15:40:30 tsutsui Exp $	*/
+/*	$NetBSD: scsi_1185.c,v 1.19.22.1 2010/12/29 08:14:43 matt Exp $	*/
 
 /*
@@ -54,9 +54,11 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: scsi_1185.c,v 1.19 2008/04/09 15:40:30 tsutsui Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: scsi_1185.c,v 1.19.22.1 2010/12/29 08:14:43 matt Exp $");
+
+#define	__INTR_PRIVATE
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/device.h>
+#include <sys/intr.h>
 
 #include <uvm/uvm_extern.h>
Index: /trunk/src/sys/arch/newsmips/include/intr.h
===================================================================
--- /trunk/src/sys/arch/newsmips/include/intr.h	(revision 151)
+++ /trunk/src/sys/arch/newsmips/include/intr.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: intr.h,v 1.23 2008/04/28 20:23:30 martin Exp $	*/
+/*	$NetBSD: intr.h,v 1.23.18.1 2010/12/29 08:14:43 matt Exp $	*/
 
 /*-
@@ -33,54 +33,13 @@
 #define _MACHINE_INTR_H_
 
-#define IPL_NONE	0	/* disable only this interrupt */
-#define IPL_SOFTCLOCK	1	/* clock software interrupts (SI 0) */
-#define IPL_SOFTBIO	1	/* bio software interrupts (SI 0) */
-#define IPL_SOFTNET	2	/* network software interrupts (SI 1) */
-#define IPL_SOFTSERIAL	2	/* serial software interrupts (SI 1) */
-#define	IPL_VM		3
-#define IPL_SCHED	4	/* disable clock interrupts */
-#define IPL_HIGH	4	/* disable all interrupts */
-
-#define _IPL_N		5
-
-#define _IPL_SI0_FIRST	IPL_SOFTCLOCK
-#define _IPL_SI0_LAST	IPL_SOFTBIO
-
-#define _IPL_SI1_FIRST	IPL_SOFTNET
-#define _IPL_SI1_LAST	IPL_SOFTSERIAL
+#include <mips/intr.h>
 
 #ifdef _KERNEL
-#ifndef _LOCORE
+#ifdef __INTR_PRIVATE
 
-#include <sys/device.h>
+#include <sys/evcnt.h>
 #include <mips/locore.h>
 
-extern const uint32_t ipl_sr_bits[_IPL_N];
-
-#define spl0()		(void)_spllower(0)
-#define splx(s)		(void)_splset(s)
-
-#define splsoft()	_splraise(ipl_sr_bits[IPL_SOFT])
-
-typedef int ipl_t;
-typedef struct {
-	ipl_t _sr;
-} ipl_cookie_t;
-
-static inline ipl_cookie_t
-makeiplcookie(ipl_t ipl)
-{
-
-	return (ipl_cookie_t){._sr = ipl_sr_bits[ipl]};
-}
-
-static inline int
-splraiseipl(ipl_cookie_t icookie)
-{
-
-	return _splraise(icookie._sr);
-}
-
-#include <sys/spl.h>
+extern const struct ipl_sr_map newmips_ipl_sr_map;
 
 struct newsmips_intrhand {
@@ -118,11 +77,7 @@
 
 /* handle i/o device interrupts */
-#ifdef news3400
-void news3400_intr(uint32_t, uint32_t, uint32_t, uint32_t);
-#endif
-#ifdef news5000
-void news5000_intr(uint32_t, uint32_t, uint32_t, uint32_t);
-#endif
-extern void (*hardware_intr)(uint32_t, uint32_t, uint32_t, uint32_t);
+void news3400_intr(int, vaddr_t, uint32_t);
+void news5000_intr(int, vaddr_t, uint32_t);
+extern void (*hardware_intr)(int, vaddr_t, uint32_t);
 
 extern void (*enable_intr)(void);
@@ -130,5 +85,5 @@
 extern void (*enable_timer)(void);
 
-#endif /* !_LOCORE */
+#endif /* __INTR_PRIVATE */
 #endif /* _KERNEL */
 #endif /* _MACHINE_INTR_H_ */
Index: /trunk/src/sys/arch/newsmips/newsmips/autoconf.c
===================================================================
--- /trunk/src/sys/arch/newsmips/newsmips/autoconf.c	(revision 151)
+++ /trunk/src/sys/arch/newsmips/newsmips/autoconf.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: autoconf.c,v 1.32 2008/02/16 22:02:15 he Exp $	*/
+/*	$NetBSD: autoconf.c,v 1.32.28.1 2010/12/29 08:14:43 matt Exp $	*/
 
 /*
@@ -86,6 +86,7 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: autoconf.c,v 1.32 2008/02/16 22:02:15 he Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: autoconf.c,v 1.32.28.1 2010/12/29 08:14:43 matt Exp $");
+
+#define __INTR_PRIVATE
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -94,4 +95,6 @@
 #include <sys/reboot.h>
 #include <sys/device.h>
+#include <sys/intr.h>
+#include <sys/cpu.h>
 
 #include <dev/scsipi/scsi_all.h>
@@ -99,5 +102,4 @@
 #include <dev/scsipi/scsiconf.h>
 
-#include <machine/cpu.h>
 #include <machine/adrsmap.h>
 #include <machine/romcall.h>
@@ -130,5 +132,5 @@
 	 * Kick off autoconfiguration
 	 */
-	_splnone();	/* enable all interrupts */
+	spl0();		/* enable all interrupts */
 	splhigh();	/* ...then disable device interrupts */
 
@@ -145,5 +147,5 @@
 
 	/* Configuration is finished, turn on interrupts. */
-	_splnone();	/* enable all source forcing SOFT_INTs cleared */
+	spl0();		/* enable all source forcing SOFT_INTs cleared */
 }
 
Index: /trunk/src/sys/arch/newsmips/newsmips/clock.c
===================================================================
--- /trunk/src/sys/arch/newsmips/newsmips/clock.c	(revision 151)
+++ /trunk/src/sys/arch/newsmips/newsmips/clock.c	(revision 152)
@@ -1,3 +1,3 @@
-/*      $NetBSD: clock.c,v 1.15 2006/09/04 20:33:24 tsutsui Exp $	*/
+/*      $NetBSD: clock.c,v 1.15.78.1 2010/12/29 08:14:43 matt Exp $	*/
 
 /*
@@ -42,13 +42,13 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: clock.c,v 1.15 2006/09/04 20:33:24 tsutsui Exp $");
+__KERNEL_RCSID(0, "$NetBSD: clock.c,v 1.15.78.1 2010/12/29 08:14:43 matt Exp $");
 
+#define __INTR_PRIVATE
 #include <sys/param.h>
 #include <sys/kernel.h>
 #include <sys/systm.h>
 #include <sys/device.h>
-
-#include <machine/cpu.h>
-#include <machine/intr.h>
+#include <sys/cpu.h>
+#include <sys/intr.h>
 
 /*
Index: /trunk/src/sys/arch/newsmips/newsmips/machdep.c
===================================================================
--- /trunk/src/sys/arch/newsmips/newsmips/machdep.c	(revision 151)
+++ /trunk/src/sys/arch/newsmips/newsmips/machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: machdep.c,v 1.98.10.5 2010/03/21 17:38:34 cliff Exp $	*/
+/*	$NetBSD: machdep.c,v 1.98.10.6 2010/12/29 08:14:43 matt Exp $	*/
 
 /*
@@ -77,5 +77,5 @@
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
 
-__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.98.10.5 2010/03/21 17:38:34 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.98.10.6 2010/12/29 08:14:43 matt Exp $");
 
 /* from: Utah Hdr: machdep.c 1.63 91/04/24 */
@@ -84,4 +84,6 @@
 #include "opt_ddb.h"
 #include "opt_execfmt.h"
+
+#define __INTR_PRIVATE
 
 #include <sys/param.h>
@@ -105,4 +107,6 @@
 #include <sys/kcore.h>
 #include <sys/ksyms.h>
+#include <sys/cpu.h>
+#include <sys/intr.h>
 
 #include <uvm/uvm_extern.h>
@@ -110,6 +114,4 @@
 #include <ufs/mfs/mfs_extern.h>		/* mfs_initminiroot() */
 
-#include <machine/cpu.h>
-#include <machine/intr.h>
 #include <machine/reg.h>
 #include <machine/psl.h>
@@ -157,5 +159,5 @@
 
 struct idrom idrom;
-void (*hardware_intr)(uint32_t, uint32_t, uint32_t, uint32_t);
+void (*hardware_intr)(int, vaddr_t, uint32_t);
 void (*enable_intr)(void);
 void (*disable_intr)(void);
@@ -598,22 +600,10 @@
 
 void
-cpu_intr(uint32_t status, uint32_t cause, uint32_t pc, uint32_t ipending)
-{
-	struct cpu_info *ci;
-
-	ci = curcpu();
+cpu_intr(int ppl, vaddr_t pc, uint32_t status)
+{
 	uvmexp.intrs++;
 
 	/* device interrupts */
-	ci->ci_idepth++;
-	(*hardware_intr)(status, cause, pc, ipending);
-	ci->ci_idepth--;
-
-#ifdef __HAVE_FAST_SOFTINTS
-	/* software interrupts */
-	ipending &= MIPS_SOFT_INT_MASK;
-	if (ipending == 0)
-		return;
-	softint_process(ipending);
-#endif
-}
+	(*hardware_intr)(ppl, pc, status);
+
+}
Index: /trunk/src/sys/arch/newsmips/newsmips/news3400.c
===================================================================
--- /trunk/src/sys/arch/newsmips/newsmips/news3400.c	(revision 151)
+++ /trunk/src/sys/arch/newsmips/newsmips/news3400.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: news3400.c,v 1.19.36.1 2010/02/01 04:18:31 matt Exp $	*/
+/*	$NetBSD: news3400.c,v 1.19.36.2 2010/12/29 08:14:43 matt Exp $	*/
 
 /*-
@@ -28,22 +28,21 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: news3400.c,v 1.19.36.1 2010/02/01 04:18:31 matt Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: news3400.c,v 1.19.36.2 2010/12/29 08:14:43 matt Exp $");
+
+#define __INTR_PRIVATE
 #include <sys/param.h>
 #include <sys/kernel.h>
 #include <sys/proc.h>
 #include <sys/systm.h>
+#include <sys/cpu.h>
+#include <sys/intr.h>
+
+#include <mips/locore.h>
 
 #include <machine/adrsmap.h>
-#include <machine/cpu.h>
-#include <machine/intr.h>
 #include <machine/psl.h>
 #include <newsmips/newsmips/machid.h>
 
 #include <newsmips/dev/hbvar.h>
-
-#if !defined(FPEMUL)
-void MachFPInterrupt(unsigned, unsigned, unsigned, struct trapframe *);
-#endif
 
 int news3400_badaddr(void *, u_int);
@@ -64,74 +63,65 @@
  */
 void
-news3400_intr(uint32_t status, uint32_t cause, uint32_t pc, uint32_t ipending)
-{
-	struct clockframe cf;
-	struct cpu_info *ci;
-
-	ci = curcpu();
-	ci->ci_idepth++;
+news3400_intr(int ppl, uint32_t pc, uint32_t status)
+{
+	uint32_t ipending;
+	int ipl;
+
+	while (ppl < (ipl = splintr(&ipending))) {
 
 	/* handle clock interrupts ASAP */
-	if (ipending & MIPS_INT_MASK_2) {
-		int stat;
-
-		stat = *(volatile uint8_t *)INTST0;
-		stat &= INTST0_TIMINT|INTST0_KBDINT|INTST0_MSINT;
-
-		*(volatile uint8_t *)INTCLR0 = stat;
-		if (stat & INTST0_TIMINT) {
-			cf.pc = pc;
-			cf.sr = status;
-			hardclock(&cf);
-			intrcnt[HARDCLOCK_INTR]++;
-			stat &= ~INTST0_TIMINT;
-		}
-
-		if (stat)
-			hb_intr_dispatch(2, stat);
-
-		cause &= ~MIPS_INT_MASK_2;
+		if (ipending & MIPS_INT_MASK_2) {
+			int stat;
+
+			stat = *(volatile uint8_t *)INTST0;
+			stat &= INTST0_TIMINT|INTST0_KBDINT|INTST0_MSINT;
+
+			*(volatile uint8_t *)INTCLR0 = stat;
+			if (stat & INTST0_TIMINT) {
+				struct clockframe cf = {
+					.pc = pc,
+					.sr = status,
+					.intr = (curcpu()->ci_idepth > 0),
+				};
+				hardclock(&cf);
+				intrcnt[HARDCLOCK_INTR]++;
+			}
+
+			if (stat)
+				hb_intr_dispatch(2, stat);
+
+		}
+
+		if (ipending & MIPS_INT_MASK_5) {
+			*(volatile uint8_t *)INTCLR0 = INTCLR0_PERR;
+			printf("Memory error interrupt(?) at 0x%x\n", pc);
+		}
+
+		/* asynchronous bus error */
+		if (ipending & MIPS_INT_MASK_4) {
+			*(volatile uint8_t *)INTCLR0 = INTCLR0_BERR;
+			badaddr_flag = 1;
+		}
+
+		if (ipending & MIPS_INT_MASK_1) {
+			news3400_level1_intr();
+		}
+
+		if (ipending & MIPS_INT_MASK_0) {
+			news3400_level0_intr();
+		}
+
+		/* FPU nofiticaition */
+		if (ipending & INT_MASK_FPU) {
+			if (!USERMODE(status))
+				panic("kernel used FPU: PC %x, SR %x",
+				      pc, status);
+
+			intrcnt[FPU_INTR]++;
+#if !defined(FPEMUL)
+			mips_fpu_intr(pc, curlwp->l_md.md_utf);
+#endif
+		}
 	}
-	/* If clock interrupts were enabled, re-enable them ASAP. */
-	_splset(MIPS_SR_INT_IE | (status & MIPS_INT_MASK_2));
-
-	if (ipending & MIPS_INT_MASK_5) {
-		*(volatile uint8_t *)INTCLR0 = INTCLR0_PERR;
-		printf("Memory error interrupt(?) at 0x%x\n", pc);
-		cause &= ~MIPS_INT_MASK_5;
-	}
-
-	/* asynchronous bus error */
-	if (ipending & MIPS_INT_MASK_4) {
-		*(volatile uint8_t *)INTCLR0 = INTCLR0_BERR;
-		cause &= ~MIPS_INT_MASK_4;
-		badaddr_flag = 1;
-	}
-
-	if (ipending & MIPS_INT_MASK_1) {
-		news3400_level1_intr();
-		cause &= ~MIPS_INT_MASK_1;
-	}
-
-	if (ipending & MIPS_INT_MASK_0) {
-		news3400_level0_intr();
-		cause &= ~MIPS_INT_MASK_0;
-	}
-
-	_splset((status & ~cause & MIPS_HARD_INT_MASK) | MIPS_SR_INT_IE);
-
-	/* FPU nofiticaition */
-	if (ipending & INT_MASK_FPU) {
-		if (!USERMODE(status))
-			panic("kernel used FPU: PC %x, CR %x, SR %x",
-			      pc, cause, status);
-
-		intrcnt[FPU_INTR]++;
-#if !defined(FPEMUL)
-		MachFPInterrupt(status, cause, pc, curlwp->l_md.md_utf);
-#endif
-	}
-
-	ci->ci_idepth--;
 }
 
Index: /trunk/src/sys/arch/newsmips/newsmips/news5000.c
===================================================================
--- /trunk/src/sys/arch/newsmips/newsmips/news5000.c	(revision 151)
+++ /trunk/src/sys/arch/newsmips/newsmips/news5000.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: news5000.c,v 1.17 2007/12/03 15:34:05 ad Exp $	*/
+/*	$NetBSD: news5000.c,v 1.17.36.1 2010/12/29 08:14:43 matt Exp $	*/
 
 /*-
@@ -28,6 +28,7 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: news5000.c,v 1.17 2007/12/03 15:34:05 ad Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: news5000.c,v 1.17.36.1 2010/12/29 08:14:43 matt Exp $");
+
+#define __INTR_PRIVATE
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -35,7 +36,7 @@
 #include <sys/timetc.h>
 #include <sys/cpu.h>
+#include <sys/intr.h>
 
 #include <machine/adrsmap.h>
-#include <machine/intr.h>
 
 #include <newsmips/apbus/apbusvar.h>
@@ -56,110 +57,100 @@
  */
 void
-news5000_intr(uint32_t status, uint32_t cause, uint32_t pc, uint32_t ipending)
-{
-	struct cpu_info *ci;
-
-	ci = curcpu();
-	ci->ci_idepth++;
-
-	if (ipending & MIPS_INT_MASK_2) {
+news5000_intr(int ppl, vaddr_t pc, uint32_t status)
+{
+	uint32_t ipending;
+	int ipl;
+
+	while (ppl < (ipl = splintr(&ipending))) {
+
+		if (ipending & MIPS_INT_MASK_2) {
 #ifdef DEBUG
-		static int l2cnt = 0;
+			static int l2cnt = 0;
 #endif
-		uint32_t int2stat;
-		struct clockframe cf;
-
-		int2stat = *(volatile uint32_t *)NEWS5000_INTST2;
+			uint32_t int2stat;
+			struct clockframe cf;
+
+			int2stat = *(volatile uint32_t *)NEWS5000_INTST2;
 
 #ifdef DEBUG
-		l2cnt++;
-		if (l2cnt == 50) {
-			*(volatile uint32_t *)NEWS5000_LED_SEC = 1;
-		}
-		if (l2cnt == 100) {
-			*(volatile uint32_t *)NEWS5000_LED_SEC = 0;
-			l2cnt = 0;
-		}
+			l2cnt++;
+			if (l2cnt == 50) {
+				*(volatile uint32_t *)NEWS5000_LED_SEC = 1;
+			}
+			if (l2cnt == 100) {
+				*(volatile uint32_t *)NEWS5000_LED_SEC = 0;
+				l2cnt = 0;
+			}
 #endif
 
-		if (int2stat & NEWS5000_INT2_TIMER0) {
-			*(volatile uint32_t *)NEWS5000_TIMER0 = 1;
-
-			cf.pc = pc;
-			cf.sr = status;
-
-			hardclock(&cf);
-			intrcnt[HARDCLOCK_INTR]++;
-		}
-
-		apbus_wbflush();
-		cause &= ~MIPS_INT_MASK_2;
+			if (int2stat & NEWS5000_INT2_TIMER0) {
+				*(volatile uint32_t *)NEWS5000_TIMER0 = 1;
+
+				cf.pc = pc;
+				cf.sr = status;
+
+				hardclock(&cf);
+				intrcnt[HARDCLOCK_INTR]++;
+			}
+
+			apbus_wbflush();
+		}
+
+		if (ipending & MIPS_INT_MASK_5) {
+			uint32_t int5stat;
+
+			int5stat = *(volatile u_int *)NEWS5000_INTST5;
+			printf("level5 interrupt (%08x)\n", int5stat);
+
+			apbus_wbflush();
+		}
+
+		if (ipending & MIPS_INT_MASK_4) {
+			uint32_t int4stat;
+
+			int4stat = *(volatile uint32_t *)NEWS5000_INTST4;
+			printf("level4 interrupt (%08x)\n", int4stat);
+			if (int4stat & NEWS5000_INT4_APBUS) {
+				uint32_t stat;
+
+				stat = *(volatile uint32_t *)NEWS5000_APBUS_INTST;
+				printf("APbus error 0x%04x\n", stat & 0xffff);
+				if (stat & NEWS5000_APBUS_INT_DMAADDR) {
+					printf("DMA Address Error: "
+					    "slot=%x, addr=0x%08x\n",
+					    *(volatile uint32_t *)NEWS5000_APBUS_DER_S,
+					    *(volatile uint32_t *)NEWS5000_APBUS_DER_A);
+				}
+				if (stat & NEWS5000_APBUS_INT_RDTIMEO)
+					printf("IO Read Timeout: addr=0x%08x\n",
+					    *(volatile uint32_t *)NEWS5000_APBUS_BER_A);
+				if (stat & NEWS5000_APBUS_INT_WRTIMEO)
+					printf("IO Write Timeout: addr=0x%08x\n",
+					    *(volatile uint32_t *)NEWS5000_APBUS_BER_A);
+				*(volatile uint32_t *)0xb4c00014 = stat;
+			}
+
+			apbus_wbflush();
+		}
+
+		if (ipending & MIPS_INT_MASK_3) {
+			uint32_t int3stat;
+
+			int3stat = *(volatile uint32_t *)NEWS5000_INTST3;
+			printf("level3 interrupt (%08x)\n", int3stat);
+
+			apbus_wbflush();
+		}
+
+		if (ipending & MIPS_INT_MASK_1) {
+			news5000_level1_intr();
+			apbus_wbflush();
+		}
+
+		if (ipending & MIPS_INT_MASK_0) {
+			news5000_level0_intr();
+			apbus_wbflush();
+		}
 	}
-	/* If clock interrupts were enabled, re-enable them ASAP. */
-	_splset(MIPS_SR_INT_IE | (status & MIPS_INT_MASK_2));
-
-	if (ipending & MIPS_INT_MASK_5) {
-		uint32_t int5stat;
-
-		int5stat = *(volatile u_int *)NEWS5000_INTST5;
-		printf("level5 interrupt (%08x)\n", int5stat);
-
-		apbus_wbflush();
-		cause &= ~MIPS_INT_MASK_5;
-	}
-
-	if (ipending & MIPS_INT_MASK_4) {
-		uint32_t int4stat;
-
-		int4stat = *(volatile uint32_t *)NEWS5000_INTST4;
-		printf("level4 interrupt (%08x)\n", int4stat);
-		if (int4stat & NEWS5000_INT4_APBUS) {
-			uint32_t stat;
-
-			stat = *(volatile uint32_t *)NEWS5000_APBUS_INTST;
-			printf("APbus error 0x%04x\n", stat & 0xffff);
-			if (stat & NEWS5000_APBUS_INT_DMAADDR) {
-				printf("DMA Address Error: "
-				    "slot=%x, addr=0x%08x\n",
-				    *(volatile uint32_t *)NEWS5000_APBUS_DER_S,
-				    *(volatile uint32_t *)NEWS5000_APBUS_DER_A);
-			}
-			if (stat & NEWS5000_APBUS_INT_RDTIMEO)
-				printf("IO Read Timeout: addr=0x%08x\n",
-				    *(volatile uint32_t *)NEWS5000_APBUS_BER_A);
-			if (stat & NEWS5000_APBUS_INT_WRTIMEO)
-				printf("IO Write Timeout: addr=0x%08x\n",
-				    *(volatile uint32_t *)NEWS5000_APBUS_BER_A);
-			*(volatile uint32_t *)0xb4c00014 = stat;
-		}
-
-		apbus_wbflush();
-		cause &= ~MIPS_INT_MASK_4;
-	}
-
-	if (ipending & MIPS_INT_MASK_3) {
-		uint32_t int3stat;
-
-		int3stat = *(volatile uint32_t *)NEWS5000_INTST3;
-		printf("level3 interrupt (%08x)\n", int3stat);
-
-		apbus_wbflush();
-		cause &= ~MIPS_INT_MASK_3;
-	}
-
-	if (ipending & MIPS_INT_MASK_1) {
-		news5000_level1_intr();
-		apbus_wbflush();
-		cause &= ~MIPS_INT_MASK_1;
-	}
-
-	if (ipending & MIPS_INT_MASK_0) {
-		news5000_level0_intr();
-		apbus_wbflush();
-		cause &= ~MIPS_INT_MASK_0;
-	}
-
-	ci->ci_idepth--;
-	_splset((status & ~cause & MIPS_HARD_INT_MASK) | MIPS_SR_INT_IE);
 }
 
Index: /trunk/src/sys/arch/pmax/conf/GENERIC64
===================================================================
--- /trunk/src/sys/arch/pmax/conf/GENERIC64	(revision 151)
+++ /trunk/src/sys/arch/pmax/conf/GENERIC64	(revision 152)
@@ -1,3 +1,3 @@
-# $NetBSD: GENERIC64,v 1.1.2.1 2009/09/08 17:24:08 matt Exp $
+# $NetBSD: GENERIC64,v 1.1.2.2 2010/12/29 00:21:28 matt Exp $
 #
 # GENERIC machine description file
@@ -23,5 +23,5 @@
 options 	INCLUDE_CONFIG_FILE	# embed config file in kernel binary
 
-#ident		"GENERIC-$Revision: 1.1.2.1 $"
+#ident		"GENERIC-$Revision: 1.1.2.2 $"
 
 maxusers	64
@@ -30,4 +30,5 @@
 
 # Support for specific models of DECstation
+options 	DEC_3MAX	# DECstation 5000/200 (kn02)
 options 	DEC_3MIN	# DECstation 5000/1xx (kn02ba), 5000/150 (kn04)
 options 	DEC_MAXINE	# Personal DECstation 5000/xx (kn02ca)
@@ -178,4 +179,14 @@
 tc*	at	mainbus0
 
+# 3MAX has TURBOchannel but no IOASIC
+ibus0	at	tc? slot ? offset ?	# 3MAX system slot
+
+# PMAX, 3MAX and MIPSMATE common devices
+mcclock* at	ibus0 addr ?		# DS1287 RTC
+dz*	at	ibus0 addr ?		# DC7085 quad line serial device
+lkkbd*	at	dz? line 0		# Keyboard
+vsms*	at	dz? line 1		# Mouse
+sii*	at	ibus0 addr ?		# DC7061 onboard SCSI`
+
 # 3MIN, 3MAX+ and MAXINE have IOASIC in system slot
 ioasic0	at	tc?
@@ -234,4 +245,5 @@
 #########################################################################
 
+scsibus* at sii?
 scsibus* at asc?
 
Index: /trunk/src/sys/arch/pmax/ibus/dz_ibus.c
===================================================================
--- /trunk/src/sys/arch/pmax/ibus/dz_ibus.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/ibus/dz_ibus.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: dz_ibus.c,v 1.9 2008/04/28 20:23:31 martin Exp $	*/
+/*	$NetBSD: dz_ibus.c,v 1.9.18.1 2010/12/29 00:12:00 matt Exp $	*/
 
 /*-
@@ -62,5 +62,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: dz_ibus.c,v 1.9 2008/04/28 20:23:31 martin Exp $");
+__KERNEL_RCSID(0, "$NetBSD: dz_ibus.c,v 1.9.18.1 2010/12/29 00:12:00 matt Exp $");
 
 #include "dzkbd.h"
@@ -137,7 +137,5 @@
 dz_ibus_match(device_t parent, cfdata_t cf, void *aux)
 {
-	struct ibus_attach_args *iba;
-
-	iba = aux;
+	struct ibus_attach_args *iba = aux;
 
 	if (strcmp(iba->ia_name, "dc") != 0 &&
@@ -158,5 +156,7 @@
 	struct dz_softc *sc = device_private(self);
 	volatile struct dzregs *dz;
+#if NDZMS > 0 || NDZKBD > 0
 	struct dzkm_attach_args daa;
+#endif
 	int i;
 
Index: /trunk/src/sys/arch/pmax/ibus/ibus.c
===================================================================
--- /trunk/src/sys/arch/pmax/ibus/ibus.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/ibus/ibus.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: ibus.c,v 1.14 2007/03/04 06:00:33 christos Exp $	*/
+/*	$NetBSD: ibus.c,v 1.14.62.1 2010/12/29 00:12:01 matt Exp $	*/
 
 /*
@@ -32,5 +32,5 @@
 
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
-__KERNEL_RCSID(0, "$NetBSD: ibus.c,v 1.14 2007/03/04 06:00:33 christos Exp $");
+__KERNEL_RCSID(0, "$NetBSD: ibus.c,v 1.14.62.1 2010/12/29 00:12:01 matt Exp $");
 
 #include <sys/param.h>
@@ -66,5 +66,5 @@
 			continue;
 
-		locs[IBUSCF_ADDR] = MIPS_KSEG1_TO_PHYS(ia->ia_addr);
+		locs[IBUSCF_ADDR] = (int32_t)MIPS_KSEG1_TO_PHYS(ia->ia_addr);
 
 		config_found_sm_loc(self, "ibus", locs, ia,
@@ -83,5 +83,5 @@
 		aprint_normal("%s at %s", ia->ia_name, pnp);
 
-	aprint_normal(" addr 0x%x", MIPS_KSEG1_TO_PHYS(ia->ia_addr));
+	aprint_normal(" addr %#"PRIxPADDR, MIPS_KSEG1_TO_PHYS(ia->ia_addr));
 
 	return (UNCONF);
@@ -93,5 +93,5 @@
 	void *cookie;
 	int level;
-	int (*handler) __P((void *));
+	int (*handler)(void *);
 	void *arg;
 {
Index: /trunk/src/sys/arch/pmax/ibus/ibus_3max.c
===================================================================
--- /trunk/src/sys/arch/pmax/ibus/ibus_3max.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/ibus/ibus_3max.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: ibus_3max.c,v 1.11 2008/05/26 10:31:22 nisimura Exp $	*/
+/*	$NetBSD: ibus_3max.c,v 1.11.16.1 2010/12/29 00:12:01 matt Exp $	*/
 
 /*-
@@ -31,5 +31,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: ibus_3max.c,v 1.11 2008/05/26 10:31:22 nisimura Exp $");
+__KERNEL_RCSID(0, "$NetBSD: ibus_3max.c,v 1.11.16.1 2010/12/29 00:12:01 matt Exp $");
 
 #include <sys/param.h>
@@ -46,16 +46,12 @@
 };
 
-static int	kn02sys_match __P((struct device *, struct cfdata *, void *));
-static void	kn02sys_attach __P((struct device *, struct device *, void *));
+static int	kn02sys_match(device_t, cfdata_t, void *);
+static void	kn02sys_attach(device_t, device_t, void *);
 
-CFATTACH_DECL(kn02sys, sizeof(struct ibus_softc),
+CFATTACH_DECL_NEW(kn02sys, 0,
     kn02sys_match, kn02sys_attach, NULL, NULL);
 
 static int
-kn02sys_match(parent, cfdata, aux)
-        struct device *parent;
-        struct cfdata *cfdata;
-        void *aux;
-
+kn02sys_match(device_t parent, cfdata_t cf, void *aux)
 {
 	struct tc_attach_args *ta = aux;
@@ -65,7 +61,5 @@
 
 static void
-kn02sys_attach(parent, self, aux)
-        struct device *parent, *self;
-        void *aux;
+kn02sys_attach(device_t parent, device_t self, void *aux)
 {
 	struct ibus_dev_attach_args ida;
@@ -73,5 +67,5 @@
 	ida.ida_busname = "ibus";
 	ida.ida_devs = kn02sys_devs;
-	ida.ida_ndevs = sizeof(kn02sys_devs)/sizeof(kn02sys_devs[0]);
+	ida.ida_ndevs = __arraycount(kn02sys_devs);
 
 	ibusattach(parent, self, &ida);
Index: /trunk/src/sys/arch/pmax/ibus/ibus_pmax.c
===================================================================
--- /trunk/src/sys/arch/pmax/ibus/ibus_pmax.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/ibus/ibus_pmax.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: ibus_pmax.c,v 1.18 2002/10/02 04:15:09 thorpej Exp $	*/
+/*	$NetBSD: ibus_pmax.c,v 1.18.130.1 2010/12/29 00:12:01 matt Exp $	*/
 
 /*
@@ -32,5 +32,5 @@
 
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
-__KERNEL_RCSID(0, "$NetBSD: ibus_pmax.c,v 1.18 2002/10/02 04:15:09 thorpej Exp $");
+__KERNEL_RCSID(0, "$NetBSD: ibus_pmax.c,v 1.18.130.1 2010/12/29 00:12:01 matt Exp $");
 
 #include "opt_dec_3100.h"
@@ -50,8 +50,8 @@
 #include <pmax/pmax/pmaxtype.h>
 
-static int	ibus_pmax_match __P((struct device *, struct cfdata *, void *));
-static void	ibus_pmax_attach __P((struct device *, struct device *, void *));
+static int	ibus_pmax_match(device_t, cfdata_t, void *);
+static void	ibus_pmax_attach(device_t, device_t, void *);
 
-CFATTACH_DECL(ibus_pmax, sizeof(struct ibus_softc),
+CFATTACH_DECL_NEW(ibus_pmax, 0,
     ibus_pmax_match, ibus_pmax_attach, NULL, NULL);
 
@@ -66,6 +66,4 @@
         { "mc146818",   SYS_DEV_BOGUS,	KV(KN01_SYS_CLOCK),     0	},
 };
-static const int ibus_pmax_ndevs =
-	sizeof(ibus_pmax_devs)/sizeof(ibus_pmax_devs[0]);
 #endif /* DEC_3100 */
 
@@ -89,6 +87,4 @@
 #endif
 };
-static const int ibus_mipsmate_ndevs =
-	sizeof(ibus_mipsmate_devs)/sizeof(ibus_mipsmate_devs[0]);
 #endif /* DEC_5100 */
 
@@ -96,8 +92,5 @@
 
 static int
-ibus_pmax_match(parent, cfdata, aux)
-        struct device *parent;
-        struct cfdata *cfdata;
-	void *aux;
+ibus_pmax_match(device_t parent, cfdata_t cf, void *aux)
 {
 	struct mainbus_attach_args *ma = aux;
@@ -114,7 +107,5 @@
 
 static void
-ibus_pmax_attach(parent, self, aux)
-        struct device *parent, *self;
-        void *aux;
+ibus_pmax_attach(device_t parent, device_t self, void *aux)
 {
 	struct ibus_dev_attach_args ida;
@@ -127,5 +118,5 @@
 	case DS_PMAX:
 		ida.ida_devs = ibus_pmax_devs;
-		ida.ida_ndevs = ibus_pmax_ndevs;
+		ida.ida_ndevs = __arraycount(ibus_pmax_devs);
 		break;
 #endif
@@ -133,5 +124,5 @@
 	case DS_MIPSMATE:
 		ida.ida_devs = ibus_mipsmate_devs;
-		ida.ida_ndevs = ibus_mipsmate_ndevs;
+		ida.ida_ndevs = __arraycount(ibus_mipsmate_devs);
 		break;
 #endif
